# To make a new EC2 instance ready
# Install poetry: curl -sSL https://install.python-poetry.org | python3 -
# Install dependencies: poetry install
# Run the evolution: PYTHONPATH=. poetry run python src/evolutionary/main/main.py

username = "ubuntu"
key_file_path = "/home/matejm/Keys/transformer-instance-ssh-key.pem"
files_to_upload = [
    "../../pyproject.toml",
    "../../poetry.lock",
    "../../libra",
    "../../experiments",
    "../../src",
]
target_folder = f"/home/{username}/thesis"
poetry_install_command = "curl -sSL https://install.python-poetry.org | python3 -"
poetry_path = f"/home/{username}/.local/bin/poetry"
run_evolution_command = f"cd {target_folder} && PYTHONPATH=. {poetry_path} run python src/evolutionary/main/main.py"
tensorboard_install_command = "pip install protobuf~=3.19.0 tensorboard"


def exec_command(client, log, command: str):
    _, stdout, stderr = client.exec_command(command)
    while True:
        err = stderr.readline()
        if err and err != "\n":
            log.error(f"> {err[:-1]}")

        out = stdout.readline()
        if out and out != "\n":
            log.info(f"> {out[:-1]}")

        if not out and not err:
            break
