import io
import os

import numpy as np
from PIL import Image
from matplotlib import pyplot as plt


def merge_mean_std_and_stringify(x, y, decimals=4, spaces=True):
    joined = [(a, b) for a, b in zip(x, y)]
    rounded = [(round(a, decimals), round(b, decimals)) for a, b in joined]
    if spaces:
        stringified = [f"{a} ± {b}" for a, b in rounded]
    else:
        stringified = [f"{a}±{b}" for a, b in rounded]
    return np.array(stringified)


def merge_two_dfs(x, y):
    joined = [(a, b) for a, b in zip(x, y)]
    stringified = [f"{a}, {b}" for a, b in joined]
    return np.array(stringified)


def save_current_figure(path: str):
    directory = "/".join(path.split("/")[:-1])
    if not os.path.exists(directory):
        os.makedirs(directory, exist_ok=True)

    buffer = io.BytesIO()
    plt.savefig(buffer, format="png")
    buffer.seek(0)
    image = Image.open(buffer)
    image.save(path)
