import unittest

import torch
from torch import nn


class GeLU(nn.Module):
    def __init__(self):
        super(GeLU, self).__init__()
        self.gelu = nn.GELU()

    def forward(self, x: torch.Tensor):
        out = self.gelu(x)
        return out


class TestGeLU(unittest.TestCase):
    def test(self):
        activation = GeLU()
        input = torch.randn(20, 100, 16)
        output = activation(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
