import unittest

import torch
from torch import nn


class ReLU(nn.Module):
    def __init__(self):
        super(ReLU, self).__init__()
        self.relu = nn.ReLU()

    def forward(self, x: torch.Tensor):
        out = self.relu(x)
        return out


class TestReLU(unittest.TestCase):
    def test(self):
        activation = ReLU()
        input = torch.randn(20, 100, 16)
        output = activation(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
