import unittest

import torch
from torch import nn


class SiLU(nn.Module):
    def __init__(self):
        super(SiLU, self).__init__()
        self.silu = nn.SiLU()

    def forward(self, x: torch.Tensor):
        out = self.silu(x)
        return out


class TestSiLU(unittest.TestCase):
    def test(self):
        activation = SiLU()
        input = torch.randn(20, 100, 16)
        output = activation(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
