import unittest

import torch
from torch import nn

# From paper: Primer: Searching for Efficient Transformers for Language Modeling


class SquaredReLU(nn.Module):
    def __init__(self):
        super(SquaredReLU, self).__init__()
        self.relu = nn.ReLU()

    def forward(self, x: torch.Tensor):
        x = self.relu(x)
        return torch.pow(x, 2)


class TestSquaredReLU(unittest.TestCase):
    def test(self):
        activation = SquaredReLU()
        input = torch.randn(20, 100, 16)
        output = activation(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
