import unittest

import torch
import torch.nn as nn


class AlphaDropout(nn.Module):
    def __init__(self, dropout):
        super(AlphaDropout, self).__init__()
        self.probability = dropout
        self.dropout = nn.AlphaDropout(dropout)

    def forward(self, x):
        return self.dropout(x)


class TestAlphaDropout(unittest.TestCase):
    def test(self):
        dropout = AlphaDropout(0.5)
        input = torch.randn(20, 100, 16)
        output = dropout(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
