import unittest

import torch
from torch import nn


class LayerNormalization(nn.Module):
    def __init__(self, embedding_dim: int):
        super(LayerNormalization, self).__init__()
        self.embedding_dim = embedding_dim
        self.norm = nn.LayerNorm(embedding_dim)

    def forward(self, x):
        return self.norm(x)


class TestLayerNormalization(unittest.TestCase):
    def test(self):
        norm = LayerNormalization(16)
        input = torch.randn(20, 100, 16)
        output = norm(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
