import torch
import torch.nn as nn


class EncoderRegression(nn.Module):
    def __init__(self, embedding_dim, input_dim, output_dim, patch_size):
        super(EncoderRegression, self).__init__()
        self.embedding_dim = embedding_dim
        self.input_dim = input_dim
        self.output_dim = output_dim
        self.patch_size = patch_size

        self.linear = nn.Linear(embedding_dim * (input_dim // patch_size), output_dim)

    def forward(self, x):
        concatenated = torch.flatten(x, start_dim=1)
        output = self.linear(concatenated)
        return output
