import torch.nn as nn


class ResidualConnection(nn.Module):
    def __init__(self, dim, dropout):
        super(ResidualConnection, self).__init__()
        self.layer_norm = nn.LayerNorm(dim)
        self.dropout = nn.Dropout(dropout)

    def forward(self, x, inner_layer):
        after_layer = inner_layer(self.layer_norm(x))
        return x + self.dropout(after_layer)
