from src.dataset.normalization.INormalizer import INormalizer


class MeanStdNormalizer(INormalizer):
    def __init__(self, dataset):
        self.mean = dataset.mean()
        self.std = dataset.std()

    def normalize(self, values):
        return (values - self.mean) / self.std

    def denormalize(self, values):
        return values * self.std + self.mean
