import copy
from enum import Enum
from typing import List

from src.dataset.normalization.MeanStdNormalizer import MeanStdNormalizer
from src.dataset.normalization.ZeroOneNormalizer import ZeroOneNormalizer


class Normalizer(Enum):
    NONE = "none"
    ZERO_ONE = "zero_one"
    MEAN_STD = "mean_std"

    @staticmethod
    def normalizer_list() -> List[Enum]:
        return [normalizer for normalizer in Normalizer]

    def module(self, dataset):
        registry = {
            Normalizer.NONE: None,
            Normalizer.ZERO_ONE: ZeroOneNormalizer(dataset),
            Normalizer.MEAN_STD: MeanStdNormalizer(dataset),
        }
        return copy.deepcopy(registry[self])
