from matplotlib import pyplot as plt

from src.dataset.utils.signal import sine_wave, linear, noise


def sine_with_sine_periodicity_and_upward_trend_series(
    length,
    sampling_rate,
    frequency1=0.002,
    amplitude1=1.0,
    frequency2=0.03,
    amplitude2=0.5,
    slope=0.003,
):
    x, y1 = sine_wave(length, sampling_rate, frequency=frequency1, amplitude=amplitude1)
    _, y2 = sine_wave(length, sampling_rate, frequency=frequency2, amplitude=amplitude2)
    _, y3 = linear(length, sampling_rate, a=slope)
    return x, y1 + y2 + y3


if __name__ == "__main__":
    length = 10000
    sampling_rate = 10
    x1, y1 = sine_with_sine_periodicity_and_upward_trend_series(
        length, sampling_rate, slope=0.0
    )
    x2, y2 = noise(length, sampling_rate, std=0.4)

    print(y2)

    plt.figure()
    plt.plot(x1, y1)
    plt.plot(x1, y1 + y2)
    plt.show()
