class TransformerLossCompute:
    def __init__(self, regression, criterion, optimizer=None):
        self.regression = regression
        self.criterion = criterion
        self.optimizer = optimizer

    def __call__(self, x, y, norm):
        x = self.regression(x)
        output = x.contiguous().view(-1)
        target = y.contiguous().view(-1)
        loss = self.criterion(output, target) / norm
        loss.backward()
        if self.optimizer is not None:
            self.optimizer.step()
            self.optimizer.optimizer.zero_grad()
        return loss.data.item() * norm
