import seaborn
from matplotlib import pyplot as plt

# TODO: these should be source and target sentence
sent = ""
tgt_sent = ""


def visualize_attention(model):
    for layer in range(1, 6, 2):
        fig, axs = plt.subplots(1, 4, figsize=(20, 10))
        print("Encoder self attention layer", layer + 1)
        for h in range(4):
            draw_heatmap(
                model.encoder._layers[layer].self_attn.attn[0, h].data,
                sent,
                sent if h == 0 else [],
                ax=axs[h],
            )
        plt.show()

    for layer in range(1, 6, 2):
        fig, axs = plt.subplots(1, 4, figsize=(20, 10))
        print("Decoder self attention layer", layer + 1)
        for h in range(4):
            draw_heatmap(
                model.decoder._layers[layer]
                .self_attn.attn[0, h]
                .data[: len(tgt_sent), : len(tgt_sent)],
                tgt_sent,
                tgt_sent if h == 0 else [],
                ax=axs[h],
            )
        plt.show()
        print("Decoder attention layer", layer + 1)
        fig, axs = plt.subplots(1, 4, figsize=(20, 10))
        for h in range(4):
            draw_heatmap(
                model.decoder._layers[layer]
                .self_attn.attn[0, h]
                .data[: len(tgt_sent), : len(sent)],
                sent,
                tgt_sent if h == 0 else [],
                ax=axs[h],
            )
        plt.show()


def draw_heatmap(data, x_labels, y_labels, ax):
    seaborn.heatmap(
        data,
        xticklabels=x_labels,
        square=True,
        yticklabels=y_labels,
        vmin=0.0,
        vmax=1.0,
        cbar=False,
        ax=ax,
    )
